#!/usr/bin/python
#
# cite.py
#
# 14th Oct 2005
#
# Am tired of writing citing stupid references!
# So am writing this small script, to read from a "standard" form of citation written as:
# <initials1>; <author1>; <initials2>; <author2>; [...]
# <volume>; <page number>; <journal name>; <year>
#
# this should be contained in a file named cite.db and the o/p will be in a file named
# cite.html
#

import sys
import string

CITATION_DB   = "cite.db"
CITATION_HTML = "cite.html"
VOL     = 0
PAGE    = 1
JOURNAL = 2
YEAR    = 3

# print the citations
def printCite(format):
   format = format.lower()

   print "Reading " + CITATION_DB + " from current directory.... \n"

   cf = open(CITATION_DB, "r")
   cflines = cf.readlines()
   cf.close()

   print "... reading over. \n" 
   print "Generating " + CITATION_HTML + " ... \n"
  
   ch = open(CITATION_HTML, "w") ;
   ch.write("<html><head></head><body><ol>");

   if (format == "jcp"):
      jcpFormat(ch, cflines);
   elif ((format == "jacs") or (format == "jpc")):
      jacsFormat(ch, cflines);
   elif (format == "jcc"):
      jccFormat(ch, cflines);
   else:
      print "Well, i have suddenly run out of options!!!!"

   ch.write("</ol></body></html>");
   ch.close();

   print "... over, enjoy! \n"

# print in JCP style
def jcpFormat(ch, cflines):
   for i in range(0, len(cflines), 2):
      print "Processing reference: ", i, cflines[i]

      authors = string.split(cflines[i], ';');
      ch.write("<li>");
      for j in range(0, len(authors), 2):
          ch.write(string.strip(authors[j]) + " " +  string.strip(authors[j+1]) + ", ");

      cite = string.split(cflines[i+1], ';'); 
      ch.write(string.strip(cite[JOURNAL]) + " <b>" + string.strip(cite[VOL]) + "</b>, "  + \
               string.strip(cite[PAGE]) + " (" + string.strip(cite[YEAR]) + ").");

      ch.write("</li>");

# print in JACS style
def jacsFormat(ch, cflines):
   for i in range(0, len(cflines), 2):
      print "Processing reference: ", i, cflines[i]

      authors = string.split(cflines[i], ';');
      ch.write("<li>");
      for j in range(0, len(authors), 2):
          ch.write(string.strip(authors[j+1]) + ", " +  string.strip(authors[j]));
          if (not (j == len(authors)-2)): ch.write("; ");

      cite = string.split(cflines[i+1], ';'); 
      ch.write(" <i>" + string.strip(cite[JOURNAL]) + "</i> <b>" + string.strip(cite[YEAR]) + ",</b><i> "  + \
               string.strip(cite[VOL]) + "</i>, " + string.strip(cite[PAGE]) + ".");

      ch.write("</li>");

# print in JCC style
def jccFormat(ch, cflines):
   for i in range(0, len(cflines), 2):
      print "Processing reference: ", i, cflines[i]

      authors = string.split(cflines[i], ';');
      ch.write("<li>");
      for j in range(0, len(authors), 2):
          ch.write(string.strip(authors[j+1]) + ", " +  string.strip(authors[j]));
          if (not (j == len(authors)-2)): ch.write("; ");

      cite = string.split(cflines[i+1], ';'); 
      ch.write(" " + string.replace(string.strip(cite[JOURNAL]), '.', '') + " " + string.strip(cite[YEAR]) + ", "  + \
               string.strip(cite[VOL]) + ", " + string.strip(cite[PAGE]) + ".");

      ch.write("</li>");

if __name__=="__main__":
   print "pycite v 1.0; (c) V.Ganesh \n"  

   if (not (len(sys.argv) == 2)):
      print "Usage: pycite.py <Journal Name> \n"
      print "Here supported Journal Names include: \n"
      print "JCP, JPC, JACS, JCTC, JTCC, JCC, THEOCHEM"

      sys.exit(10)

   printCite(sys.argv[1])
